QGIS Application - Bug report #2700

Adding a layer from py plugin, with QgsVectorLayer.setEditForminit (QString function) set

2010-05-08 11:58 AM - jaanussuvi -

Status: Closed
Priority: Low
Assignee:

Category: Python plugins

Affected QGIS version:

Operating System: Windows
Pull Request or Patch supplied:
Crashes QGIS or corrupts data:

Regression?: No
Easy fix?: No
Resolution: fixed

Copied to github as #: 12760

Description

Briefly about my case:

| created a python plugin,

and it creates [[QgsVectorLayer]]'s from Postgis database.

| do add gml styles to my layers, with layer.loadNamedStyle(path_to_gml).
And in gml i've specified form init functions in python <editforminit>myInitMethod</editforminit>
I'm trying to initilize some data fields with editforminit function.

The problem:

1) i add a layer with my plugin

2) select the added layer which has <editforminit> specified

3) toggle the layer to edit mode

4) try to add a layer object to map, click on the map

5) then qgis always craches

Problem is only when i have set editforminit function.

butif i do
steps

- (save project)

- (close and open qgis)

before adding new object to my layer, then editforminit function is invoked and everything works.

Maybe there's a workaround?
Maybe some refreshing?

| do after adding layers:

self.iface.refreshLegend(myLayer)

self.iface.mapCanvas().refresh()
History

#1 - 2010-05-11 02:57 AM - Giovanni Manghi

Hi,

feedback to your problem the problem would be better asked in the developer mailing list.

#2 - 2010-05-25 11:00 AM - Alex Mandel

Needs to be retested on a newer trunk, not a showstopper for release.

#3 - 2010-06-20 10:30 AM - Martin Dobias

This could have been fixed recently in commit:52a49¢c90 (SVN r13752), please test again.

If the problem persists, please provide further information how to replicate the problem. Can you simply add a layer and set a QML with "editforminit"

function to get the crash (without using the plugin)?

#4 - 2010-07-24 03:56 PM - Giuseppe Sucameli

No user's inputs for 5 weeks...

| tick the "awaiting user input" checkbox and hope.

#5 - 2010-07-24 04:31 PM - jaanussuvi -

Replying to [comment:4 wonder]:

This could have been fixed recently in commit:52a49c90 (SVN r13752), please test again.

Sorry, I've finished my project with the plugin, and i do not have development environment setup anymore. So it's really time consuming to test it. btw the

plugin doesn't use custom editform or init function. | solved it differently.

| think this approach was too complex anyway.

If the problem persists, please provide further information how to replicate the problem. Can you simply add a layer and set a QML with "editforminit"

function to get the crash (without using the plugin)?

Yes, if i add a postgis layer to my qgis project with custom editform, then it works fine. But if i add postgis layer with python, and try to add new object to the

layer, then it does not work. But if i save newly created layer to gqis project and restart gqis, then it works.

How to replicate:

Also complex task, if not having the setup.

| believe it could be done with python console.

U should have postgis db and gml for some geo object.

in gml of course <editforminit>myInitMethod</editforminit>
Code that creates vector layer from postgis:

uri = qgis.core.QgsDataSourceURI()

uri.setDataSource("your_schema", "your_geo_table", "the_geom", subset_sql)
vl = qgis.core.QgsVectorLayer(uri.uri(), "layer_name", "postgres")
vl.loadNamedStyle(QString(gml_path + "vl.gml"))
qgis.core.QgsMapLayerRegistry.instance().addMapLayer(vl, True)
self.iface.refreshLegend(vl

self.iface.mapCanvas().refresh()

Sorry, i'm too busy with new projects.
| hope my description helps.

#6 - 2010-09-19 08:57 AM - Paolo Cavallini
- Resolution set to fixed
- Status changed from Open to Closed

Closing it pending reporter check. Please reopen it if necessary.
